/*
#include <asf.h>
#include "inc/mavlink_bridge_header.h"
#include "inc/mavlink1/common/mavlink.h"
#include <string.h>
#include <stringz.h>
#include <stdlib.h>

#define SPI_EXAMPLE						  &AVR32_SPI
#define SPI_SLAVECHIP_NUMBER			  0
#define IDLE							  0
#define SAMPLING						  1
#define LINKED							  2
#define USART1_SERIAL                     &AVR32_USART1
#define USART1_SERIAL_BAUDRATE            57600
#define USART1_SERIAL_CHAR_LENGTH         8
#define USART1_SERIAL_PARITY              USART_NO_PARITY
#define USART1_SERIAL_STOP_BIT            USART_1_STOPBIT
#define USART2_SERIAL                     &AVR32_USART2
#define USART2_SERIAL_BAUDRATE            9600
#define USART2_SERIAL_CHAR_LENGTH         8
#define USART2_SERIAL_PARITY              USART_NO_PARITY
#define USART2_SERIAL_STOP_BIT            USART_1_STOPBIT
#define MAVLINK_COMM_NUM_BUFFERS 1
#define PIX_SYSID	1
#define PIX_CMPID	1
#define STREAM_START	1
#define STREAM_STOP		0
#define TRUE	1
#define FALSE	0

uint8_t read_data(uint16_t address);
void spi_init_module(void);
void set_write_latch(void);
void reset_write_latch(void);
void read_status_register(void);
void write_data(uint16_t address, uint8_t data);
uint8_t read_data(uint16_t address);
void write_mapping(unsigned short adc_value, uint16_t gps_coords);
void requestData();
void stopData();
void beatHeart();

spi_options_t my_spi_options={SPI_SLAVECHIP_NUMBER,1000000, 8, 5, 5, 1, SPI_MODE_0, 1};
	
usart_options_t usart1_options={
	.baudrate = USART1_SERIAL_BAUDRATE,   
	.charlength = USART1_SERIAL_CHAR_LENGTH,   
	.paritytype = USART1_SERIAL_PARITY,   
	.stopbits = USART1_SERIAL_STOP_BIT,
	.channelmode = USART_NORMAL_CHMODE,
	};

usart_options_t usart2_options={
	.baudrate = USART2_SERIAL_BAUDRATE,
	.charlength = USART2_SERIAL_CHAR_LENGTH,
	.paritytype = USART2_SERIAL_PARITY,
	.stopbits = USART2_SERIAL_STOP_BIT,
	.channelmode = USART_NORMAL_CHMODE,
};

uint16_t coords;
uint16_t eepromAddress;
uint8_t received_byte;
uint8_t txdata;
uint8_t rxdata;
uint8_t STATE;
uint8_t WP;
uint8_t LINK;
uint8_t SAMPLERATE;

mavlink_message_t command;

static const gpio_map_t SPI_GPIO_MAP = {
	{AVR32_SPI_SCK_0_0_PIN,AVR32_SPI_SCK_0_0_FUNCTION},
	{AVR32_SPI_MISO_0_0_PIN,AVR32_SPI_MISO_0_0_FUNCTION},
	{AVR32_SPI_MOSI_0_0_PIN,AVR32_SPI_MOSI_0_0_FUNCTION},
	{AVR32_SPI_NPCS_0_0_PIN,AVR32_SPI_NPCS_0_0_FUNCTION}
	};

static const gpio_map_t USART0_GPIO_MAP = {
	//{AVR32_USART0_CLK_0_1_PIN,AVR32_USART0_CLK_0_1_FUNCTION},
	{AVR32_USART0_TXD_0_0_PIN,AVR32_USART0_TXD_0_0_FUNCTION},
	{AVR32_USART0_RXD_0_0_PIN,AVR32_USART0_RXD_0_0_FUNCTION},
	};

static const gpio_map_t USART1_GPIO_MAP = {
	//{AVR32_USART1_CLK_0_PIN,AVR32_USART1_CLK_0_FUNCTION},
	{AVR32_USART1_TXD_0_0_PIN,AVR32_USART1_TXD_0_0_FUNCTION},
	{AVR32_USART1_RXD_0_0_PIN,AVR32_USART1_RXD_0_0_FUNCTION},
};

static const gpio_map_t USART2_GPIO_MAP = {
	//{AVR32_USART2_CLK_0_PIN,AVR32_USART2_CLK_0_FUNCTION},
	{AVR32_USART2_TXD_0_0_PIN,AVR32_USART2_TXD_0_0_FUNCTION},
	{AVR32_USART2_RXD_0_0_PIN,AVR32_USART2_RXD_0_0_FUNCTION},
};


uint8_t get_sample_rate(){
	
};

void spi_init_module(void){
	spi_initMaster(SPI_EXAMPLE,&my_spi_options);
	spi_setupChipReg(SPI_EXAMPLE,&my_spi_options,sysclk_get_pba_hz()); 
	spi_enable(SPI_EXAMPLE);
	}

void set_write_latch(void){
	spi_selectChip(SPI_EXAMPLE, SPI_SLAVECHIP_NUMBER);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	spi_put(SPI_EXAMPLE,0x06);
	while(!spi_is_tx_empty(SPI_EXAMPLE));
	spi_unselectChip(SPI_EXAMPLE, SPI_SLAVECHIP_NUMBER);
	gpio_set_pin_high(AVR32_PIN_PA16);
}

void reset_write_latch(void){
	spi_selectChip(SPI_EXAMPLE, SPI_SLAVECHIP_NUMBER);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	spi_put(SPI_EXAMPLE,0x04);
	while(!spi_is_tx_empty(SPI_EXAMPLE));
	spi_unselectChip(SPI_EXAMPLE, SPI_SLAVECHIP_NUMBER);
	gpio_set_pin_high(AVR32_PIN_PA16);
}

void read_status_register(void){
	spi_selectChip(SPI_EXAMPLE, SPI_SLAVECHIP_NUMBER);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	spi_put(SPI_EXAMPLE,0x05);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	spi_put(SPI_EXAMPLE,0x00);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	spi_put(SPI_EXAMPLE,0x00);
	while(!spi_is_tx_empty(SPI_EXAMPLE));
	spi_unselectChip(SPI_EXAMPLE, SPI_SLAVECHIP_NUMBER);
	gpio_set_pin_high(AVR32_PIN_PA16);
}

void write_data(uint16_t address, uint8_t data){
	spi_selectChip(SPI_EXAMPLE, SPI_SLAVECHIP_NUMBER);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	spi_put(SPI_EXAMPLE,0x02);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	txdata=address>>8;
	spi_put(SPI_EXAMPLE,txdata);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	txdata=address;
	spi_put(SPI_EXAMPLE,txdata);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	txdata=data;
	spi_put(SPI_EXAMPLE,txdata);
	while(!spi_is_tx_empty(SPI_EXAMPLE));
	spi_unselectChip(SPI_EXAMPLE, SPI_SLAVECHIP_NUMBER);
	gpio_set_pin_high(AVR32_PIN_PA16);
}

uint8_t read_data(uint16_t address){
	spi_selectChip(SPI_EXAMPLE, SPI_SLAVECHIP_NUMBER);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	spi_put(SPI_EXAMPLE,0x03);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	txdata=address>>8;
	spi_put(SPI_EXAMPLE,txdata);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	txdata=address;
	spi_put(SPI_EXAMPLE,txdata);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	spi_put(SPI_EXAMPLE,0x00);
	while(!spi_is_tx_ready(SPI_EXAMPLE));
	spi_put(SPI_EXAMPLE,0x00);
	while(!spi_is_tx_empty(SPI_EXAMPLE));
	while(!spi_is_rx_ready(SPI_EXAMPLE));
	rxdata=spi_get(SPI_EXAMPLE);
	spi_unselectChip(SPI_EXAMPLE, SPI_SLAVECHIP_NUMBER);
	gpio_set_pin_high(AVR32_PIN_PA16);
	return rxdata;
}

void write_mapping(uint16_t adc_value, uint32_t gps_lat, uint32_t gps_lon){
	uint8_t mappingData;
	set_write_latch();
	for(int i=2;i>0;i--){
		mappingData= adc_value>>(8*(i-1));
		write_data(eepromAddress, mappingData);
		eepromAddress=eepromAddress++;
	}
	for(int i=4;i>0;i--){
		mappingData= gps_lat>>(8*(i-1));
		write_data(eepromAddress, mappingData);
		eepromAddress=eepromAddress++;
	}
	for(int i=4;i>0;i--){
		mappingData= gps_lon>>(8*(i-1));
		write_data(eepromAddress, mappingData);
		eepromAddress=eepromAddress++;
	}
	write_data(eepromAddress,'\n');
	eepromAddress=eepromAddress++;
}


int main2 (void)
{
	//Initializes Clock
	sysclk_init();
	//Initializes Board
	board_init();
	//Initializes SPI0
	spi_init_module();
	//Initializes USART1
	usart_serial_init(&AVR32_USART1, &usart1_options);
	//Initializes USART2
	usart_serial_init(&AVR32_USART2, &usart2_options);
	//enables SPI0 pins
	gpio_enable_module(SPI_GPIO_MAP,sizeof(SPI_GPIO_MAP)/sizeof(SPI_GPIO_MAP[0]));
	//enables USART1 Pins
	gpio_enable_module(USART1_GPIO_MAP,sizeof(USART1_GPIO_MAP)/sizeof(USART1_GPIO_MAP[0]));
	//enables USART2 Pins
	gpio_enable_module(USART2_GPIO_MAP,sizeof(USART2_GPIO_MAP)/sizeof(USART2_GPIO_MAP[0]));
	//Initializes ADC
	adc_configure(&AVR32_ADC);
	//Sets ADC to use pin 8
	gpio_configure_pin(AVR32_PIN_PA04,GPIO_DIR_INPUT);
	//Enables ADC Channel 1
	adc_enable(&AVR32_ADC,AVR32_ADC_CH1);
	//Starts ADC Sampling
	adc_start(&AVR32_ADC);
	//Initializes to IDLE State
	STATE=0;
	//Initializes Memory address to 0x0000
	eepromAddress = 0x0000;
	uint8_t pcLinkFlag;
	uint8_t mavChar;
	
	uint8_t beatCount=0;
	uint8_t tmp_count=0;
	uint8_t GPSReceived=0;
	
	mavlink_system.sysid = 255;
	mavlink_system.compid = 1;
	
	mavlink_message_t msg;
	mavlink_status_t status;
	
	//Everything Initialized Properly
	gpio_set_gpio_pin(AVR32_PIN_PA13);
	
	while(1){
		//State machine starts
		switch(STATE){
		//IDLE state checks for either PC Link Flag or confirmation that First WP is reached.
		case IDLE:
			while(STATE==IDLE){
				if(usart_read_char(&AVR32_USART2, pcLinkFlag)==0){
					//If host PC sends link character, state goes to LINKED to download data
					if(pcLinkFlag==1){
						STATE=LINKED;
						break;
					}
				}
				usart_serial_getchar(&AVR32_USART1,mavChar);
				if(mavlink_parse_char(MAVLINK_COMM_0,mavChar,&msg,&status)){
					switch(msg.msgid){
						case MAVLINK_MSG_ID_HEARTBEAT:
							
							beatCount++;
							if ((beatCount>2)&&(!GPSReceived))
							{
								requestData();
								beatCount=0;
							}
							// toggle pin for every beat
							break;
						
						case MAVLINK_MSG_ID_MISSION_CURRENT:
							if(msg.seq==1){
								STATE=SAMPLING;
								break;
							}
							
						default:
							break;
					}
				}
			}
			break;
			
		case SAMPLING:
			uint32_t lat;
			uint32_t lon;
			uint32_t alt;
		    uint16_t adc_value_temp;

			//SAMPLERATE = get_sample_rate();
			while(STATE==SAMPLING){
				//Starts monitoring MAVLINK Messages from the flight controller
				usart_serial_getchar(&AVR32_USART1,mavChar);
				if(mavlink_parse_char(MAVLINK_COMM_0,mavChar,&msg,&status)){
					switch(msg.msgid){
						case MAVLINK_MSG_ID_HEARTBEAT:
						
						beatCount++;
						if ((beatCount>2)&&(!GPSReceived))
						{
							requestData();
							beatCount=0;
						}
						// toggle pin for every beat
						break;
						//If GPS Message is received: latitude, longitude, and signal intesities are sampled and mapped 
						case MAVLINK_MSG_ID_GPS_RAW_INT:
							
							// Lat
							lat=mavlink_msg_gps_raw_int_get_lat(&msg);
							
							// Lon
							lon=mavlink_msg_gps_raw_int_get_lon(&msg);
														
							// Lon
							alt=mavlink_msg_gps_raw_int_get_alt(&msg);
							//Signal Intensity
							adc_value_temp = adc_get_value(&AVR32_ADC,AVR32_ADC_CH1);
							//Write data to storage
							write_mapping(adc_value_temp, lat,lon);
							break;
						
						case MAVLINK_MSG_ID_MISSION_CURRENT:
							//If last WP is reached state machine goes back to IDLE and awaits PC Link or new mission.
							if(msg.seq == 50){
								STATE=IDLE;
								break;
							}
						
						default:
						break;
					}
				//delays 1 second for next cycle
				delay_ms(1000);
			}
			break;
			
		case LINKED:
			uint16_t addressCounter = eepromAddress;
			char c;
			//Sends signal to host pc that data is incoming
			usart_serial_putchar(&AVR32_USART2,'g');
			while(addressCounter>0){
				if(usart_serial_putchar(&AVR32_USART2,read_data(addressCounter))){
					usart_serial_getchar(&AVR32_USART2,c);
					if(c=='g'){
					addressCounter=addressCounter-8;
					}
				}
			}
			break;
	}

void requestData()
{
	
	//mavlink_msg_request_data_stream_send(MAVLINK_COMM_0, PIX_SYSID, PIX_CMPID,  MAV_DATA_STREAM_RAW_SENSORS, 0x02, STREAM_START);
	mavlink_msg_request_data_stream_send(MAVLINK_COMM_0, PIX_SYSID, PIX_CMPID,  MAV_DATA_STREAM_EXTENDED_STATUS, 0x02, STREAM_START);		// THIS FOR GPS CORDS
	//mavlink_msg_command_long_send(MAVLINK_COMM_0, PIX_SYSID, PIX_CMPID, MAV_CMD_NAV_RETURN_TO_LAUNCH, 1,0,0,0,0,0,0,0);
	//mavlink_msg_command_long_send(MAVLINK_COMM_0, PIX_SYSID, PIX_CMPID, MAV_CMD_SET_MESSAGE_INTERVAL, 1, MAVLINK_MSG_ID_GPS_RAW_INT, 500000, 0,0,0,0,0);		// 500000uS interval
}
void stopData()
{
	//mavlink_msg_request_data_stream_send(MAVLINK_COMM_0, PIX_SYSID, PIX_CMPID,  MAV_DATA_STREAM_RAW_SENSORS, 0x02, STREAM_START);
	mavlink_msg_request_data_stream_send(MAVLINK_COMM_0, PIX_SYSID, PIX_CMPID,  MAV_DATA_STREAM_ALL, 0x02, STREAM_STOP);
	
}
void beatHeart()
{
	// heartbeat format: (MAVLINK_COMM_0, MAV_TYPE, MAV_AUTOPILOT, MAV_MODE_FLAG, CUSTOM, MAV_STATE)
	mavlink_msg_heartbeat_send(MAVLINK_COMM_0, MAV_TYPE_ONBOARD_CONTROLLER, MAV_AUTOPILOT_GENERIC, MAV_MODE_FLAG_STABILIZE_ENABLED, 0, MAV_STATE_ACTIVE);
}
*/